Last Comment Bug 1244425 - Avoid CPOW when setting file array on <input type=file>
: Avoid CPOW when setting file array on <input type=file>
Status: RESOLVED FIXED
:
Product: Testing
Classification: Components
Component: Marionette (show other bugs)
: unspecified
: All All
-- normal (vote)
: mozilla51
Assigned To: Andreas Tolfsen ‹:ato›
:
:
Mentors:
Depends on: 1280947
Blocks: 1238095
  Show dependency treegraph
 
Reported: 2016-01-30 00:29 PST by Andreas Tolfsen ‹:ato›
Modified: 2016-09-28 17:26 PDT (History)
6 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
fix-optional
-
fixed
-
fixed

MozReview Requests
Submitter Diff Changes Open Issues Last Updated
Loading...
Error loading review requests:
Show discarded requests

Attachments
Bug 1244425 - Avoid CPOW when setting file array on <input type=file>; (58 bytes, text/x-review-board-request)
2016-08-30 04:58 PDT, Andreas Tolfsen ‹:ato›
dburns: review+
Details | Review

Description User image Andreas Tolfsen ‹:ato› 2016-01-30 00:29:05 PST
Marionette passes an element reference from the content frame script to chrome space in order to gain access to element.mozSetFileArray, so users can set a file for <input type=file>.

This functionality is currently implemented in the Marionette:setElementValue message handler in GeckoDriver#sendKeysToElement: https://dxr.mozilla.org/mozilla-central/rev/d4213241bb796fdfa7a5ad4f1989e97b44474364/testing/marionette/driver.js#2208

Bug 1233497 outlaws the use of CPOWs but Marionette currently circumvents this by disabling the throwing via a preference.

We should avoid using a CPOW for this.
Comment 1 User image Andreas Tolfsen ‹:ato› 2016-08-25 09:31:03 PDT
It looks like constructing File objects in content space is now (somehow) not broken anymore:

    let file = new File(path);
    let fs = Array.prototype.slice.call(inputEl.files);
    fs.push(file);
    inputEl.mozSetFileArray(fs);
Comment 2 User image Andreas Tolfsen ‹:ato› 2016-08-25 09:32:28 PDT
Making this depend on bug 1280947 as it contains some improvements to how we call mozSetFileArray.
Comment 3 User image Andreas Tolfsen ‹:ato› 2016-08-30 04:58:32 PDT Comment hidden (mozreview-request)
Comment 4 User image David Burns :automatedtester 2016-08-30 09:51:37 PDT
Comment on attachment 8786321 [details]
Bug 1244425 - Avoid CPOW when setting file array on <input type=file>;

https://reviewboard.mozilla.org/r/75306/#review73212
Comment 5 User image Andreas Tolfsen ‹:ato› 2016-08-31 05:01:33 PDT Comment hidden (mozreview-request)
Comment 6 User image Pulsebot 2016-08-31 05:03:24 PDT
Pushed by atolfsen@mozilla.com:
https://hg.mozilla.org/integration/autoland/rev/6c382a30453a
Avoid CPOW when setting file array on <input type=file>; r=automatedtester
Comment 7 User image Wes Kocher (:KWierso) 2016-08-31 16:56:17 PDT
https://hg.mozilla.org/mozilla-central/rev/6c382a30453a
Comment 8 User image Andreas Tolfsen ‹:ato› 2016-09-01 05:16:54 PDT
Test only changes.  Depends on bug 1280947.
Comment 10 User image Wes Kocher (:KWierso) 2016-09-01 12:06:28 PDT
https://hg.mozilla.org/releases/mozilla-beta/rev/afd10ab995e0
Comment 12 User image Liz Henry (:lizzard) (needinfo? me) 2016-09-09 08:17:00 PDT
We are very late in beta now but could still take uplift for 50.
Comment 13 User image Ritu Kothari (:ritu) 2016-09-22 15:02:27 PDT
[Tracking Requested - why for this release]: Now that 50 is on the Beta channel, I would not block on this but we should consider fixing this test in Aurora 51.

Hi Andreas, David, do we plan to uplift this test fix in Aurora51?
Comment 14 User image David Burns :automatedtester 2016-09-25 17:39:45 PDT
I am pretty sure the reason this failed on uplift was because of a dep which should be in all the way to beta. I will let Andreas run a test to check that we have a clean build/test of beta
Comment 15 User image Andreas Tolfsen ‹:ato› 2016-09-26 03:09:24 PDT
I’m unsure about the tracking vs. status flags on this bug:

tracking-firefox51: 	?
status-firefox51: 	fixed 

It says it’s been fixed in Firefox 51 but is not tracking.  Where do I find out what Firefox version is currently in Aurora/Beta and so on?
Comment 16 User image David Burns :automatedtester 2016-09-26 04:23:06 PDT
Firefox 50 is in Beta at the moment 

Details can be found in https://wiki.mozilla.org/RapidRelease/Calendar
Comment 17 User image Gerry Chang [:gchang] 2016-09-27 01:51:37 PDT
Un track 51 as it's fixed.
Comment 18 User image Andreas Tolfsen ‹:ato› 2016-09-27 04:33:43 PDT
Patch applied cleanly on beta, try run: https://treeherder.mozilla.org/#/jobs?repo=try&revision=0766b9418af8
Comment 19 User image Andreas Tolfsen ‹:ato› 2016-09-27 06:24:28 PDT
Patch seems fine.  Requesting uplift again.
Comment 20 User image Ryan VanderMeulen [:RyanVM] 2016-09-28 17:26:12 PDT
https://hg.mozilla.org/releases/mozilla-beta/rev/e9c597887c21

Note You need to log in before you can comment on or make changes to this bug.